/* 
 *  Licensed Materials - Property of IBM 
 *  Component IBM Rational ROSE_RT BUILD : TARGET_RTS 
 *  (c) Copyright IBM Corporation 1991, 2006 All Rights Reserved. 
 */

#ifndef __RTTimespec_h__
#define __RTTimespec_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTObject_class_h__
#include <RTObject_class.h>
#endif

class RTInterval;
class RTTime;

struct RTTimespec
{
    long tv_sec;  // seconds
    long tv_nsec; // nanoseconds

    RTS_INLINE              RTTimespec( void );
    RTS_INLINE              RTTimespec( long, long );

						    RTTimespec( const RTInterval & ); //lint !e1931
							RTTimespec( const RTTime     & ); //lint !e1931
    RTS_INLINE              RTTimespec( const RTTimespec & );

    void                    normalize( void );

    RTS_INLINE RTTimespec & operator=( const RTTimespec & );

    RTTimespec            & operator+=( const RTTimespec & );
    RTTimespec            & operator-=( const RTTimespec & );

    long                    ticksFromNow( long nanoseconds_per_tick ) const;

    static void             getclock( RTTimespec & );

    static const RTTimespec zero;

    static const RTObject_class classData;

#define RTType_RTTimespec ( RTTimespec::classData )
};

RTS_INLINE int operator==( const RTTimespec &, const RTTimespec & );
RTS_INLINE int operator!=( const RTTimespec &, const RTTimespec & );
RTS_INLINE int operator<=( const RTTimespec &, const RTTimespec & );
RTS_INLINE int operator> ( const RTTimespec &, const RTTimespec & );
RTS_INLINE int operator>=( const RTTimespec &, const RTTimespec & );
RTS_INLINE int operator< ( const RTTimespec &, const RTTimespec & );
RTTimespec     operator+ ( const RTTimespec &, const RTTimespec & );
RTTimespec     operator- ( const RTTimespec &, const RTTimespec & );

struct RTTypedValue_RTTimespec
{
    const void           * data;
    const RTObject_class * type;

    RTS_INLINE RTTypedValue_RTTimespec( const RTTimespec     & ); //lint !e1931
    RTS_INLINE RTTypedValue_RTTimespec( const RTTimespec     &,
					const RTObject_class * );
}; //lint !e1712

#if RTS_INLINES
#include <RTTimespec.inl>
#endif

#endif // __RTTimespec_h__
