/* 
 *  Licensed Materials - Property of IBM 
 *  Component IBM Rational ROSE_RT BUILD : TARGET_RTS 
 *  (c) Copyright IBM Corporation 1991, 2006 All Rights Reserved. 
 */

#ifndef __RTTimespec_inl__
#define __RTTimespec_inl__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTTimespec_h__
#include <RTTimespec.h>
#endif

RTS_INLINE RTTimespec::RTTimespec( void )
    : tv_sec ( 0L )
    , tv_nsec( 0L )
{
}

RTS_INLINE RTTimespec::RTTimespec( long s, long n )
    : tv_sec ( s )
    , tv_nsec( n )
{
}

RTS_INLINE RTTimespec::RTTimespec( const RTTimespec & other )
    : tv_sec ( other.tv_sec  )
    , tv_nsec( other.tv_nsec )
{
}

RTS_INLINE RTTimespec & RTTimespec::operator=( const RTTimespec & rhs )
{
    tv_sec  = rhs.tv_sec;
    tv_nsec = rhs.tv_nsec;

    return *this;
} //lint !e1529

RTS_INLINE int operator==( const RTTimespec & lhs, const RTTimespec & rhs )
{
    return lhs.tv_sec  == rhs.tv_sec
	&& lhs.tv_nsec == rhs.tv_nsec;
}

RTS_INLINE int operator!=( const RTTimespec & lhs, const RTTimespec & rhs )
{
    return ( lhs == rhs ) == 0;
}

RTS_INLINE int operator<=( const RTTimespec & lhs, const RTTimespec & rhs )
{
    return lhs.tv_sec == rhs.tv_sec && lhs.tv_nsec <= rhs.tv_nsec
	|| lhs.tv_sec  < rhs.tv_sec;
}

RTS_INLINE int operator>( const RTTimespec & lhs, const RTTimespec & rhs )
{
    return ( lhs <= rhs ) == 0;
}

RTS_INLINE int operator>=( const RTTimespec & lhs, const RTTimespec & rhs )
{
    return lhs.tv_sec == rhs.tv_sec && lhs.tv_nsec >= rhs.tv_nsec
	|| lhs.tv_sec  > rhs.tv_sec;
}

RTS_INLINE int operator<( const RTTimespec & lhs, const RTTimespec & rhs )
{
    return ( lhs >= rhs ) == 0;
}

RTS_INLINE
RTTypedValue_RTTimespec::
RTTypedValue_RTTimespec( const RTTimespec & _value )
    : data( &_value )
    , type( &RTType_RTTimespec )
{
}

RTS_INLINE
RTTypedValue_RTTimespec::
RTTypedValue_RTTimespec( const RTTimespec     & _value,
			 const RTObject_class * _type )
    : data( &_value )
    , type( _type   )
{
}

#endif // __RTTimespec_inl__
