/* 
 *  Licensed Materials - Property of IBM 
 *  Component IBM Rational ROSE_RT BUILD : TARGET_RTS 
 *  (c) Copyright IBM Corporation 1991, 2006 All Rights Reserved. 
 */

#include <RTCmdLineObserver.h>
#include <RTEventInfo.h>
#include <RTFormat.h>
#include <RTMemoryUtil.h>

int RTCmdLineObserver::evtRtsStatus( int,             // daemonId
				     const RTEventInfo & info )
{
    char buf[ 64 ];

    (void)RTFormat::_long( (long)info.timestamp.tv_sec, buf, (int)sizeof( buf ) );
    (void)sendData( buf, RTMemoryUtil::strlen( buf ) );

    RTMemoryUtil::memset( &buf[ 1 ], (int)'0', 9 );

    int offset = RTFormat::_long( (long)info.timestamp.tv_nsec,
				  &buf[ 10 ], (int)sizeof( buf ) - 10 );
    buf[ offset ] = '.';
    (void)sendData( &buf[ offset ], RTMemoryUtil::strlen( &buf[ offset ] ) );

    (void)sendData( ": Target is ", RTMemoryUtil::strlen( ": Target is " ) );

    const char * s;

    switch( info.targetMode )
    {
	case RTEventInfo::Halted:   s = "stopped\r\n";  break;
	case RTEventInfo::Stepping: s = "stepping\r\n"; break;
	case RTEventInfo::Running:  s = "running\r\n";  break;
	default:                    s = "?\r\n";        break;
    }

    (void)sendData( s, RTMemoryUtil::strlen( s ) );

    return 0;
}
