/* 
 *  Licensed Materials - Property of IBM 
 *  Component IBM Rational ROSE_RT BUILD : TARGET_RTS 
 *  (c) Copyright IBM Corporation 1991, 2005 All Rights Reserved. 
 */

#include <RTDiag.h>
#include <RTTimespec.h>

long RTTimespec::ticksFromNow( long nanos_per_tick ) const
{
    RTAssert( nanos_per_tick > 0L );

    RTTimespec now;

    getclock( now );

    if( *this <= now ) //lint !e909
	return 0L;

    RTTimespec delta( *this );

    delta -= now;

    long tick_rate = 1000000000L / nanos_per_tick;
    long result    = tick_rate * delta.tv_sec + delta.tv_nsec / nanos_per_tick;

    // avoid very long timeouts by limiting results
    if( result < 0L )
	result = (long)( ((unsigned long)~0) >> 1 );
    else if( result == 0L )
	// apply lower bound when this is in the future
	result = 1L;

    return result;
}
